﻿using System;
using System.Threading;
using ZylSoft.Gps;

namespace CoreTest
{
    class Program
    {
        static void Main(string[] args)
        {
            GpsReceiver gpsReceiver = new GpsReceiver();
            gpsReceiver.Received += new System.EventHandler<ZylSoft.Gps.DataEventArgs>(Program.gpsReceiver_Received);
            gpsReceiver.Position3DChanged += new System.EventHandler<ZylSoft.Gps.DmsPositionEventArgs>(gpsReceiver_Position3DChanged);
            gpsReceiver.Port = SerialCommPort.COM2;
            gpsReceiver.BaudRate = SerialBaudRate.Br004800;
            Console.WriteLine("Press enter to open " + gpsReceiver.Port.ToString());
            Console.ReadLine();
            if (!gpsReceiver.Open())
            {
                Console.WriteLine("Cannot open " + gpsReceiver.Port.ToString());
            }
            bool eventFired = false;
            while (!eventFired) { }
        }

        private static void gpsReceiver_Received(object sender, ZylSoft.Gps.DataEventArgs e)
        {
            Console.WriteLine(e.Buffer.ToString());
        }

        private static void gpsReceiver_Position3DChanged(object sender, DmsPositionEventArgs e)
        {
            if (e.Position.IsFix())
            {
                Console.WriteLine("Latitude: " + e.Position.LatitudeAsDecimalDegrees.ToString());
                Console.WriteLine("Longitude: " + e.Position.LongitudeAsDecimalDegrees.ToString());
                Console.WriteLine("Altitude: " + e.Position.Altitude.ToString());
            }
        }
    }
}
