using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using ZylSoft.Gps;
using ZylSoft.Gps.GMaps;

namespace GMapsDemo
{	
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button btnOpen;
		private System.Windows.Forms.Button btnClose;	
		private System.Windows.Forms.ListBox lstPorts;

		private System.Windows.Forms.TextBox textBoxOut;
		private System.Windows.Forms.GroupBox groupBox3;
		private System.Windows.Forms.Label label12;
		private System.Windows.Forms.Label label11;
		private System.Windows.Forms.Label label10;
		private System.Windows.Forms.Label label9;
		private System.Windows.Forms.TextBox textBoxSatCount;
		private System.Windows.Forms.TextBox textBoxCourse;
		private System.Windows.Forms.TextBox textBoxSpeed;
		private System.Windows.Forms.TextBox textBoxAlt;
		private System.Windows.Forms.GroupBox groupBox2;
		private System.Windows.Forms.Label label8;
		private System.Windows.Forms.Label label7;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.TextBox textBoxLongDir;
		private System.Windows.Forms.TextBox textBoxLongSec;
		private System.Windows.Forms.TextBox textBoxLongMin;
		private System.Windows.Forms.TextBox textBoxLongDeg;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.TextBox textBoxLatDir;
		private System.Windows.Forms.TextBox textBoxLatSec;
		private System.Windows.Forms.TextBox textBoxLatMin;
		private System.Windows.Forms.TextBox textBoxLatDeg;
		private ZylSoft.Gps.GpsReceiver gpsReceiver;
		private System.Windows.Forms.Label label14;
		private System.Windows.Forms.Label label13;
		private System.Windows.Forms.Label lblLocalTime;
		private System.Windows.Forms.Label lblUTCTime;
        private PictureBox pBox;
        private ListBox lstBaudRate;
        private Label label15;
        private Label label16;
        private Button btnDetect;
        private Button btnCancel;
        private Label lblDetect;
		private System.ComponentModel.IContainer components;
        private Map gMaps;
        private GroupBox groupBoxMapProvider;
        private RadioButton radioButtonOsm;
        private RadioButton radioButtonGoogleMaps;
        private bool m_DetectCancel = false;

        // This delegate enables asynchronous calls for setting
        // the text property on a TextBox control.
        delegate void SetTextCallback(string text);

        private delegate void RefreshPaintBoxCallBack();

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.components = new System.ComponentModel.Container();
            ZylSoft.Gps.GMaps.Marker marker1 = new ZylSoft.Gps.GMaps.Marker();
            ZylSoft.Gps.GMaps.FontStyle fontStyle1 = new ZylSoft.Gps.GMaps.FontStyle();
            ZylSoft.Gps.Position position1 = new ZylSoft.Gps.Position();
            this.textBoxOut = new System.Windows.Forms.TextBox();
            this.lstPorts = new System.Windows.Forms.ListBox();
            this.btnOpen = new System.Windows.Forms.Button();
            this.btnClose = new System.Windows.Forms.Button();
            this.groupBox3 = new System.Windows.Forms.GroupBox();
            this.label12 = new System.Windows.Forms.Label();
            this.label11 = new System.Windows.Forms.Label();
            this.label10 = new System.Windows.Forms.Label();
            this.label9 = new System.Windows.Forms.Label();
            this.textBoxSatCount = new System.Windows.Forms.TextBox();
            this.textBoxCourse = new System.Windows.Forms.TextBox();
            this.textBoxSpeed = new System.Windows.Forms.TextBox();
            this.textBoxAlt = new System.Windows.Forms.TextBox();
            this.groupBox2 = new System.Windows.Forms.GroupBox();
            this.label8 = new System.Windows.Forms.Label();
            this.label7 = new System.Windows.Forms.Label();
            this.label6 = new System.Windows.Forms.Label();
            this.label5 = new System.Windows.Forms.Label();
            this.textBoxLongDir = new System.Windows.Forms.TextBox();
            this.textBoxLongSec = new System.Windows.Forms.TextBox();
            this.textBoxLongMin = new System.Windows.Forms.TextBox();
            this.textBoxLongDeg = new System.Windows.Forms.TextBox();
            this.groupBox1 = new System.Windows.Forms.GroupBox();
            this.label4 = new System.Windows.Forms.Label();
            this.label3 = new System.Windows.Forms.Label();
            this.label2 = new System.Windows.Forms.Label();
            this.label1 = new System.Windows.Forms.Label();
            this.textBoxLatDir = new System.Windows.Forms.TextBox();
            this.textBoxLatSec = new System.Windows.Forms.TextBox();
            this.textBoxLatMin = new System.Windows.Forms.TextBox();
            this.textBoxLatDeg = new System.Windows.Forms.TextBox();
            this.label14 = new System.Windows.Forms.Label();
            this.label13 = new System.Windows.Forms.Label();
            this.lblLocalTime = new System.Windows.Forms.Label();
            this.lblUTCTime = new System.Windows.Forms.Label();
            this.pBox = new System.Windows.Forms.PictureBox();
            this.lstBaudRate = new System.Windows.Forms.ListBox();
            this.label15 = new System.Windows.Forms.Label();
            this.label16 = new System.Windows.Forms.Label();
            this.btnDetect = new System.Windows.Forms.Button();
            this.btnCancel = new System.Windows.Forms.Button();
            this.lblDetect = new System.Windows.Forms.Label();
            this.gMaps = new ZylSoft.Gps.GMaps.Map();
            this.gpsReceiver = new ZylSoft.Gps.GpsReceiver(this.components);
            this.groupBoxMapProvider = new System.Windows.Forms.GroupBox();
            this.radioButtonOsm = new System.Windows.Forms.RadioButton();
            this.radioButtonGoogleMaps = new System.Windows.Forms.RadioButton();
            this.groupBox3.SuspendLayout();
            this.groupBox2.SuspendLayout();
            this.groupBox1.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.pBox)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.gMaps)).BeginInit();
            this.groupBoxMapProvider.SuspendLayout();
            this.SuspendLayout();
            // 
            // textBoxOut
            // 
            this.textBoxOut.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
            | System.Windows.Forms.AnchorStyles.Left)));
            this.textBoxOut.Location = new System.Drawing.Point(10, 107);
            this.textBoxOut.Multiline = true;
            this.textBoxOut.Name = "textBoxOut";
            this.textBoxOut.ReadOnly = true;
            this.textBoxOut.ScrollBars = System.Windows.Forms.ScrollBars.Both;
            this.textBoxOut.Size = new System.Drawing.Size(355, 0);
            this.textBoxOut.TabIndex = 0;
            // 
            // lstPorts
            // 
            this.lstPorts.ItemHeight = 15;
            this.lstPorts.Items.AddRange(new object[] {
            "COM1",
            "COM2",
            "COM3",
            "COM4",
            "COM5",
            "COM6",
            "COM7",
            "COM8",
            "COM9",
            "COM10",
            "COM11",
            "COM12",
            "COM13",
            "COM14",
            "COM15",
            "COM16",
            "COM17",
            "COM18",
            "COM19",
            "COM20",
            "COM21",
            "COM22",
            "COM23",
            "COM24",
            "COM25",
            "COM26",
            "COM27",
            "COM28",
            "COM29",
            "COM30",
            "COM31",
            "COM32",
            "COM33",
            "COM34",
            "COM35",
            "COM36",
            "COM37",
            "COM38",
            "COM39"});
            this.lstPorts.Location = new System.Drawing.Point(10, 31);
            this.lstPorts.Name = "lstPorts";
            this.lstPorts.Size = new System.Drawing.Size(76, 49);
            this.lstPorts.TabIndex = 1;
            // 
            // btnOpen
            // 
            this.btnOpen.Location = new System.Drawing.Point(179, 39);
            this.btnOpen.Name = "btnOpen";
            this.btnOpen.Size = new System.Drawing.Size(90, 29);
            this.btnOpen.TabIndex = 2;
            this.btnOpen.Text = "Open";
            this.btnOpen.Click += new System.EventHandler(this.btnOpen_Click);
            // 
            // btnClose
            // 
            this.btnClose.Location = new System.Drawing.Point(179, 71);
            this.btnClose.Name = "btnClose";
            this.btnClose.Size = new System.Drawing.Size(90, 29);
            this.btnClose.TabIndex = 3;
            this.btnClose.Text = "Close";
            this.btnClose.Click += new System.EventHandler(this.btnClose_Click);
            // 
            // groupBox3
            // 
            this.groupBox3.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
            this.groupBox3.Controls.Add(this.label12);
            this.groupBox3.Controls.Add(this.label11);
            this.groupBox3.Controls.Add(this.label10);
            this.groupBox3.Controls.Add(this.label9);
            this.groupBox3.Controls.Add(this.textBoxSatCount);
            this.groupBox3.Controls.Add(this.textBoxCourse);
            this.groupBox3.Controls.Add(this.textBoxSpeed);
            this.groupBox3.Controls.Add(this.textBoxAlt);
            this.groupBox3.Location = new System.Drawing.Point(10, 299);
            this.groupBox3.Name = "groupBox3";
            this.groupBox3.Size = new System.Drawing.Size(355, 89);
            this.groupBox3.TabIndex = 9;
            this.groupBox3.TabStop = false;
            // 
            // label12
            // 
            this.label12.Location = new System.Drawing.Point(269, 30);
            this.label12.Name = "label12";
            this.label12.Size = new System.Drawing.Size(67, 19);
            this.label12.TabIndex = 7;
            this.label12.Text = "Sat Count";
            // 
            // label11
            // 
            this.label11.Location = new System.Drawing.Point(182, 30);
            this.label11.Name = "label11";
            this.label11.Size = new System.Drawing.Size(68, 19);
            this.label11.TabIndex = 6;
            this.label11.Text = "Course";
            // 
            // label10
            // 
            this.label10.Location = new System.Drawing.Point(96, 30);
            this.label10.Name = "label10";
            this.label10.Size = new System.Drawing.Size(58, 19);
            this.label10.TabIndex = 5;
            this.label10.Text = "Speed";
            // 
            // label9
            // 
            this.label9.Location = new System.Drawing.Point(10, 30);
            this.label9.Name = "label9";
            this.label9.Size = new System.Drawing.Size(67, 19);
            this.label9.TabIndex = 4;
            this.label9.Text = "Altitude";
            // 
            // textBoxSatCount
            // 
            this.textBoxSatCount.Location = new System.Drawing.Point(269, 49);
            this.textBoxSatCount.Name = "textBoxSatCount";
            this.textBoxSatCount.ReadOnly = true;
            this.textBoxSatCount.Size = new System.Drawing.Size(77, 23);
            this.textBoxSatCount.TabIndex = 3;
            // 
            // textBoxCourse
            // 
            this.textBoxCourse.Location = new System.Drawing.Point(182, 49);
            this.textBoxCourse.Name = "textBoxCourse";
            this.textBoxCourse.ReadOnly = true;
            this.textBoxCourse.Size = new System.Drawing.Size(77, 23);
            this.textBoxCourse.TabIndex = 2;
            // 
            // textBoxSpeed
            // 
            this.textBoxSpeed.Location = new System.Drawing.Point(96, 49);
            this.textBoxSpeed.Name = "textBoxSpeed";
            this.textBoxSpeed.ReadOnly = true;
            this.textBoxSpeed.Size = new System.Drawing.Size(77, 23);
            this.textBoxSpeed.TabIndex = 1;
            // 
            // textBoxAlt
            // 
            this.textBoxAlt.Location = new System.Drawing.Point(10, 49);
            this.textBoxAlt.Name = "textBoxAlt";
            this.textBoxAlt.ReadOnly = true;
            this.textBoxAlt.Size = new System.Drawing.Size(76, 23);
            this.textBoxAlt.TabIndex = 0;
            // 
            // groupBox2
            // 
            this.groupBox2.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
            this.groupBox2.Controls.Add(this.label8);
            this.groupBox2.Controls.Add(this.label7);
            this.groupBox2.Controls.Add(this.label6);
            this.groupBox2.Controls.Add(this.label5);
            this.groupBox2.Controls.Add(this.textBoxLongDir);
            this.groupBox2.Controls.Add(this.textBoxLongSec);
            this.groupBox2.Controls.Add(this.textBoxLongMin);
            this.groupBox2.Controls.Add(this.textBoxLongDeg);
            this.groupBox2.Location = new System.Drawing.Point(10, 201);
            this.groupBox2.Name = "groupBox2";
            this.groupBox2.Size = new System.Drawing.Size(355, 89);
            this.groupBox2.TabIndex = 8;
            this.groupBox2.TabStop = false;
            this.groupBox2.Text = "Longitude";
            // 
            // label8
            // 
            this.label8.Location = new System.Drawing.Point(269, 30);
            this.label8.Name = "label8";
            this.label8.Size = new System.Drawing.Size(67, 19);
            this.label8.TabIndex = 7;
            this.label8.Text = "Direction";
            // 
            // label7
            // 
            this.label7.Location = new System.Drawing.Point(182, 30);
            this.label7.Name = "label7";
            this.label7.Size = new System.Drawing.Size(68, 19);
            this.label7.TabIndex = 6;
            this.label7.Text = "Second";
            // 
            // label6
            // 
            this.label6.Location = new System.Drawing.Point(96, 30);
            this.label6.Name = "label6";
            this.label6.Size = new System.Drawing.Size(67, 19);
            this.label6.TabIndex = 5;
            this.label6.Text = "Minute";
            // 
            // label5
            // 
            this.label5.Location = new System.Drawing.Point(10, 30);
            this.label5.Name = "label5";
            this.label5.Size = new System.Drawing.Size(67, 19);
            this.label5.TabIndex = 4;
            this.label5.Text = "Degree";
            // 
            // textBoxLongDir
            // 
            this.textBoxLongDir.Location = new System.Drawing.Point(269, 49);
            this.textBoxLongDir.Name = "textBoxLongDir";
            this.textBoxLongDir.ReadOnly = true;
            this.textBoxLongDir.Size = new System.Drawing.Size(77, 23);
            this.textBoxLongDir.TabIndex = 3;
            // 
            // textBoxLongSec
            // 
            this.textBoxLongSec.Location = new System.Drawing.Point(182, 49);
            this.textBoxLongSec.Name = "textBoxLongSec";
            this.textBoxLongSec.ReadOnly = true;
            this.textBoxLongSec.Size = new System.Drawing.Size(77, 23);
            this.textBoxLongSec.TabIndex = 2;
            // 
            // textBoxLongMin
            // 
            this.textBoxLongMin.Location = new System.Drawing.Point(96, 49);
            this.textBoxLongMin.Name = "textBoxLongMin";
            this.textBoxLongMin.ReadOnly = true;
            this.textBoxLongMin.Size = new System.Drawing.Size(77, 23);
            this.textBoxLongMin.TabIndex = 1;
            // 
            // textBoxLongDeg
            // 
            this.textBoxLongDeg.Location = new System.Drawing.Point(10, 49);
            this.textBoxLongDeg.Name = "textBoxLongDeg";
            this.textBoxLongDeg.ReadOnly = true;
            this.textBoxLongDeg.Size = new System.Drawing.Size(76, 23);
            this.textBoxLongDeg.TabIndex = 0;
            // 
            // groupBox1
            // 
            this.groupBox1.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
            this.groupBox1.Controls.Add(this.label4);
            this.groupBox1.Controls.Add(this.label3);
            this.groupBox1.Controls.Add(this.label2);
            this.groupBox1.Controls.Add(this.label1);
            this.groupBox1.Controls.Add(this.textBoxLatDir);
            this.groupBox1.Controls.Add(this.textBoxLatSec);
            this.groupBox1.Controls.Add(this.textBoxLatMin);
            this.groupBox1.Controls.Add(this.textBoxLatDeg);
            this.groupBox1.Location = new System.Drawing.Point(10, 102);
            this.groupBox1.Name = "groupBox1";
            this.groupBox1.Size = new System.Drawing.Size(355, 89);
            this.groupBox1.TabIndex = 7;
            this.groupBox1.TabStop = false;
            this.groupBox1.Text = "Latitude";
            // 
            // label4
            // 
            this.label4.Location = new System.Drawing.Point(269, 30);
            this.label4.Name = "label4";
            this.label4.Size = new System.Drawing.Size(67, 19);
            this.label4.TabIndex = 7;
            this.label4.Text = "Direction";
            // 
            // label3
            // 
            this.label3.Location = new System.Drawing.Point(182, 30);
            this.label3.Name = "label3";
            this.label3.Size = new System.Drawing.Size(58, 19);
            this.label3.TabIndex = 6;
            this.label3.Text = "Second";
            // 
            // label2
            // 
            this.label2.Location = new System.Drawing.Point(96, 30);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(120, 19);
            this.label2.TabIndex = 5;
            this.label2.Text = "Minute";
            // 
            // label1
            // 
            this.label1.Location = new System.Drawing.Point(10, 30);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(67, 19);
            this.label1.TabIndex = 4;
            this.label1.Text = "Degree";
            // 
            // textBoxLatDir
            // 
            this.textBoxLatDir.Location = new System.Drawing.Point(269, 49);
            this.textBoxLatDir.Name = "textBoxLatDir";
            this.textBoxLatDir.ReadOnly = true;
            this.textBoxLatDir.Size = new System.Drawing.Size(77, 23);
            this.textBoxLatDir.TabIndex = 3;
            // 
            // textBoxLatSec
            // 
            this.textBoxLatSec.Location = new System.Drawing.Point(182, 49);
            this.textBoxLatSec.Name = "textBoxLatSec";
            this.textBoxLatSec.ReadOnly = true;
            this.textBoxLatSec.Size = new System.Drawing.Size(77, 23);
            this.textBoxLatSec.TabIndex = 2;
            // 
            // textBoxLatMin
            // 
            this.textBoxLatMin.Location = new System.Drawing.Point(96, 49);
            this.textBoxLatMin.Name = "textBoxLatMin";
            this.textBoxLatMin.ReadOnly = true;
            this.textBoxLatMin.Size = new System.Drawing.Size(77, 23);
            this.textBoxLatMin.TabIndex = 1;
            // 
            // textBoxLatDeg
            // 
            this.textBoxLatDeg.Location = new System.Drawing.Point(10, 49);
            this.textBoxLatDeg.Name = "textBoxLatDeg";
            this.textBoxLatDeg.ReadOnly = true;
            this.textBoxLatDeg.Size = new System.Drawing.Size(76, 23);
            this.textBoxLatDeg.TabIndex = 0;
            // 
            // label14
            // 
            this.label14.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
            this.label14.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point);
            this.label14.Location = new System.Drawing.Point(750, 441);
            this.label14.Name = "label14";
            this.label14.Size = new System.Drawing.Size(87, 28);
            this.label14.TabIndex = 17;
            this.label14.Text = "Local Time:";
            // 
            // label13
            // 
            this.label13.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
            this.label13.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point);
            this.label13.Location = new System.Drawing.Point(750, 414);
            this.label13.Name = "label13";
            this.label13.Size = new System.Drawing.Size(87, 28);
            this.label13.TabIndex = 16;
            this.label13.Text = "UTC Time:";
            this.label13.Click += new System.EventHandler(this.label13_Click);
            // 
            // lblLocalTime
            // 
            this.lblLocalTime.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
            this.lblLocalTime.AutoSize = true;
            this.lblLocalTime.Location = new System.Drawing.Point(844, 441);
            this.lblLocalTime.Name = "lblLocalTime";
            this.lblLocalTime.Size = new System.Drawing.Size(12, 15);
            this.lblLocalTime.TabIndex = 15;
            this.lblLocalTime.Text = "?";
            // 
            // lblUTCTime
            // 
            this.lblUTCTime.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
            this.lblUTCTime.AutoSize = true;
            this.lblUTCTime.Location = new System.Drawing.Point(844, 414);
            this.lblUTCTime.Name = "lblUTCTime";
            this.lblUTCTime.Size = new System.Drawing.Size(12, 15);
            this.lblUTCTime.TabIndex = 14;
            this.lblUTCTime.Text = "?";
            // 
            // pBox
            // 
            this.pBox.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
            this.pBox.Location = new System.Drawing.Point(750, 39);
            this.pBox.Name = "pBox";
            this.pBox.Size = new System.Drawing.Size(426, 357);
            this.pBox.TabIndex = 18;
            this.pBox.TabStop = false;
            this.pBox.Paint += new System.Windows.Forms.PaintEventHandler(this.pBox_Paint);
            // 
            // lstBaudRate
            // 
            this.lstBaudRate.ItemHeight = 15;
            this.lstBaudRate.Items.AddRange(new object[] {
            "75",
            "110",
            "134",
            "150",
            "300",
            "600",
            "1200",
            "2400",
            "4800",
            "7200",
            "9600",
            "14400",
            "19200",
            "38400",
            "57600",
            "115200",
            "128000",
            "230400",
            "256000",
            "460800",
            "921600"});
            this.lstBaudRate.Location = new System.Drawing.Point(95, 31);
            this.lstBaudRate.Name = "lstBaudRate";
            this.lstBaudRate.Size = new System.Drawing.Size(77, 49);
            this.lstBaudRate.TabIndex = 19;
            // 
            // label15
            // 
            this.label15.AutoSize = true;
            this.label15.Location = new System.Drawing.Point(6, 11);
            this.label15.Name = "label15";
            this.label15.Size = new System.Drawing.Size(32, 15);
            this.label15.TabIndex = 20;
            this.label15.Text = "Port:";
            // 
            // label16
            // 
            this.label16.AutoSize = true;
            this.label16.Location = new System.Drawing.Point(91, 11);
            this.label16.Name = "label16";
            this.label16.Size = new System.Drawing.Size(63, 15);
            this.label16.TabIndex = 21;
            this.label16.Text = "Baud Rate:";
            // 
            // btnDetect
            // 
            this.btnDetect.Location = new System.Drawing.Point(179, 7);
            this.btnDetect.Name = "btnDetect";
            this.btnDetect.Size = new System.Drawing.Size(90, 29);
            this.btnDetect.TabIndex = 22;
            this.btnDetect.Text = "Detect";
            this.btnDetect.Click += new System.EventHandler(this.btnDetect_Click);
            // 
            // btnCancel
            // 
            this.btnCancel.Location = new System.Drawing.Point(275, 7);
            this.btnCancel.Name = "btnCancel";
            this.btnCancel.Size = new System.Drawing.Size(90, 29);
            this.btnCancel.TabIndex = 23;
            this.btnCancel.Text = "Cancel";
            this.btnCancel.Click += new System.EventHandler(this.btnCancel_Click);
            // 
            // lblDetect
            // 
            this.lblDetect.AutoSize = true;
            this.lblDetect.Location = new System.Drawing.Point(275, 39);
            this.lblDetect.Name = "lblDetect";
            this.lblDetect.Size = new System.Drawing.Size(12, 15);
            this.lblDetect.TabIndex = 24;
            this.lblDetect.Text = "?";
            // 
            // gMaps
            // 
            this.gMaps.AllowExternalDrop = true;
            this.gMaps.CenterPosition = null;
            marker1.Draggable = false;
            marker1.Icon = "";
            marker1.Label = "";
            marker1.Popup = null;
            fontStyle1.Bold = false;
            fontStyle1.ForeColor = System.Drawing.Color.Empty;
            marker1.PopupFontStyle = fontStyle1;
            position1.Altitude = 0D;
            position1.Course = 0D;
            position1.Day = 1;
            position1.Fix = -1;
            position1.GeoHeight = 0D;
            position1.Hdop = -1D;
            position1.Heading = 0D;
            position1.Hour = 0;
            position1.LatitudeDegree = 0;
            position1.LatitudeDirection = ZylSoft.Gps.CardinalPoint.North;
            position1.LatitudeMinute = 0;
            position1.LatitudeSecond = 0D;
            position1.LongitudeDegree = 0;
            position1.LongitudeDirection = ZylSoft.Gps.CardinalPoint.West;
            position1.LongitudeMinute = 0;
            position1.LongitudeSecond = 0D;
            position1.MagneticCourse = 0D;
            position1.MagneticDeviation = 0D;
            position1.MagneticDeviationDirection = ZylSoft.Gps.CardinalPoint.North;
            position1.MagneticHeading = 0D;
            position1.MagneticVariation = 0D;
            position1.MagneticVariationDirection = ZylSoft.Gps.CardinalPoint.East;
            position1.Millisecond = 0;
            position1.Minute = 0;
            position1.Mode1 = ((uint)(1u));
            position1.Mode2 = ((uint)(1u));
            position1.Month = 1;
            position1.Pdop = -1D;
            position1.SatelliteCount = ((uint)(0u));
            position1.Second = 0;
            position1.SpeedAsKmh = 0D;
            position1.SpeedAsKnots = 0D;
            position1.Vdop = -1D;
            position1.Year = 1900;
            marker1.Position = position1;
            marker1.Text = "";
            marker1.TextWidth = ((uint)(25u));
            marker1.Title = "";
            marker1.Visible = true;
            this.gMaps.CenterPositionMarker = marker1;
            this.gMaps.CreationProperties = null;
            this.gMaps.DefaultBackgroundColor = System.Drawing.Color.FromArgb(((int)(((byte)(255)))), ((int)(((byte)(255)))), ((int)(((byte)(255)))));
            this.gMaps.Location = new System.Drawing.Point(384, 62);
            this.gMaps.MapProvider = ZylSoft.Gps.GMaps.MapProvider.GoogleMaps;
            this.gMaps.MapType = ZylSoft.Gps.GMaps.MapType.SatelliteWithStreetNames;
            this.gMaps.Name = "gMaps";
            this.gMaps.ShowPointsOfInterest = true;
            this.gMaps.Size = new System.Drawing.Size(355, 372);
            this.gMaps.Source = new System.Uri("about:blank", System.UriKind.Absolute);
            this.gMaps.TabIndex = 0;
            this.gMaps.Zoom = ((uint)(16u));
            this.gMaps.ZoomFactor = 1D;
            // 
            // gpsReceiver
            // 
            this.gpsReceiver.AutoReconnect = false;
            this.gpsReceiver.AutoReconnectCheckInterval = 4000;
            this.gpsReceiver.BaudRate = ZylSoft.Gps.SerialBaudRate.Br004800;
            this.gpsReceiver.CloseWhenLineStatusIsZero = true;
            this.gpsReceiver.CustomBaudRate = ((uint)(0u));
            this.gpsReceiver.CustomPortName = "port1";
            this.gpsReceiver.DataWidth = ZylSoft.Gps.SerialDataWidth.Dw8Bits;
            this.gpsReceiver.EnableDtrOnOpen = false;
            this.gpsReceiver.EnableRtsOnOpen = false;
            this.gpsReceiver.ForceChecksum = true;
            this.gpsReceiver.HardwareFlowControl = ZylSoft.Gps.SerialHardwareFlowControl.None;
            this.gpsReceiver.IdleInterval = 30000;
            this.gpsReceiver.InputBuffer = 4096;
            this.gpsReceiver.Interval = 1000;
            this.gpsReceiver.LogDateTime = true;
            this.gpsReceiver.LogFile = "d:\\gpsnet.txt";
            this.gpsReceiver.LogNmea = true;
            this.gpsReceiver.MinCheckDisconnectedInterval = 50;
            this.gpsReceiver.NeedSynchronization = false;
            this.gpsReceiver.NmeaSentencePrefix = "$";
            this.gpsReceiver.NmeaSentences = ZylSoft.Gps.NmeaSentences.All;
            this.gpsReceiver.NmeaSentenceTerminator = "\r\n";
            this.gpsReceiver.NmeaSentenceTerminator2 = "\r";
            this.gpsReceiver.OutputBuffer = 4096;
            this.gpsReceiver.ParityBits = ZylSoft.Gps.SerialParityBits.None;
            this.gpsReceiver.Port = ZylSoft.Gps.SerialCommPort.COM2;
            this.gpsReceiver.Priority = System.Threading.ThreadPriority.Normal;
            this.gpsReceiver.SatelliteTypes = ZylSoft.Gps.SatelliteTypes.All;
            this.gpsReceiver.SkipSetupFailed = false;
            this.gpsReceiver.SoftwareFlowControl = ZylSoft.Gps.SerialSoftwareFlowControl.None;
            this.gpsReceiver.StopBits = ZylSoft.Gps.SerialStopBits.Sb1Bit;
            this.gpsReceiver.Connected += new System.EventHandler<ZylSoft.Gps.ConnectionEventArgs>(this.gpsReceiver_Connected);
            this.gpsReceiver.Disconnected += new System.EventHandler<ZylSoft.Gps.ConnectionEventArgs>(this.gpsReceiver_Disconnected);
            this.gpsReceiver.Faulted += new System.EventHandler<ZylSoft.Gps.ConnectionEventArgs>(this.gpsReceiver_Faulted);
            this.gpsReceiver.Detecting += new System.EventHandler<ZylSoft.Gps.DetectEventArgs>(this.gpsReceiver_Detecting);
            this.gpsReceiver.Idle += new System.EventHandler<System.EventArgs>(this.gpsReceiver_Idle);
            this.gpsReceiver.Resumed += new System.EventHandler<System.EventArgs>(this.gpsReceiver_Resume);
            this.gpsReceiver.Received += new System.EventHandler<ZylSoft.Gps.DataEventArgs>(this.serialPort_Received);
            this.gpsReceiver.LatitudeChanged += new System.EventHandler<ZylSoft.Gps.PositionEventArgs>(this.gpsReceiver_LatitudeChanged);
            this.gpsReceiver.LongitudeChanged += new System.EventHandler<ZylSoft.Gps.PositionEventArgs>(this.gpsReceiver_LongitudeChanged);
            this.gpsReceiver.AltitudeChanged += new System.EventHandler<ZylSoft.Gps.ParamEventArgs>(this.gpsReceiver_AltitudeChanged);
            this.gpsReceiver.HeadingChanged += new System.EventHandler<ZylSoft.Gps.ParamEventArgs>(this.gpsReceiver_HeadingChanged);
            this.gpsReceiver.CourseChanged += new System.EventHandler<ZylSoft.Gps.ParamEventArgs>(this.gpsReceiver_CourseChanged);
            this.gpsReceiver.SpeedChanged += new System.EventHandler<ZylSoft.Gps.ParamEventArgs>(this.gpsReceiver_SpeedChanged);
            this.gpsReceiver.Position2DChanged += new System.EventHandler<ZylSoft.Gps.DmsPositionEventArgs>(this.gpsReceiver_Position2DChanged);
            this.gpsReceiver.SatelliteReceived += new System.EventHandler<ZylSoft.Gps.SatelliteEventArgs>(this.gpsReceiver_SatelliteReceived);
            this.gpsReceiver.SatellitesReceived += new System.EventHandler<System.EventArgs>(this.gpsReceiver_SatellitesReceived);
            this.gpsReceiver.WaypointReceived += new System.EventHandler<ZylSoft.Gps.WaypointEventArgs>(this.gpsReceiver_WaypointReceived);
            this.gpsReceiver.ActiveRouteReceived += new System.EventHandler<System.EventArgs>(this.gpsReceiver_ActiveRouteReceived);
            // 
            // groupBoxMapProvider
            // 
            this.groupBoxMapProvider.Controls.Add(this.radioButtonOsm);
            this.groupBoxMapProvider.Controls.Add(this.radioButtonGoogleMaps);
            this.groupBoxMapProvider.Location = new System.Drawing.Point(384, 7);
            this.groupBoxMapProvider.Name = "groupBoxMapProvider";
            this.groupBoxMapProvider.Size = new System.Drawing.Size(355, 49);
            this.groupBoxMapProvider.TabIndex = 25;
            this.groupBoxMapProvider.TabStop = false;
            // 
            // radioButtonOsm
            // 
            this.radioButtonOsm.AutoSize = true;
            this.radioButtonOsm.Checked = true;
            this.radioButtonOsm.Location = new System.Drawing.Point(218, 23);
            this.radioButtonOsm.Name = "radioButtonOsm";
            this.radioButtonOsm.Size = new System.Drawing.Size(114, 19);
            this.radioButtonOsm.TabIndex = 1;
            this.radioButtonOsm.TabStop = true;
            this.radioButtonOsm.Text = "Open Street Map";
            this.radioButtonOsm.UseVisualStyleBackColor = true;
            // 
            // radioButtonGoogleMaps
            // 
            this.radioButtonGoogleMaps.AutoSize = true;
            this.radioButtonGoogleMaps.Location = new System.Drawing.Point(11, 23);
            this.radioButtonGoogleMaps.Name = "radioButtonGoogleMaps";
            this.radioButtonGoogleMaps.Size = new System.Drawing.Size(95, 19);
            this.radioButtonGoogleMaps.TabIndex = 0;
            this.radioButtonGoogleMaps.Text = "Google Maps";
            this.radioButtonGoogleMaps.UseVisualStyleBackColor = true;
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(6, 16);
            this.ClientSize = new System.Drawing.Size(1177, 478);
            this.Controls.Add(this.groupBoxMapProvider);
            this.Controls.Add(this.gMaps);
            this.Controls.Add(this.lblDetect);
            this.Controls.Add(this.btnCancel);
            this.Controls.Add(this.btnDetect);
            this.Controls.Add(this.label16);
            this.Controls.Add(this.label15);
            this.Controls.Add(this.lstBaudRate);
            this.Controls.Add(this.pBox);
            this.Controls.Add(this.label14);
            this.Controls.Add(this.label13);
            this.Controls.Add(this.lblLocalTime);
            this.Controls.Add(this.lblUTCTime);
            this.Controls.Add(this.groupBox3);
            this.Controls.Add(this.groupBox2);
            this.Controls.Add(this.groupBox1);
            this.Controls.Add(this.btnClose);
            this.Controls.Add(this.btnOpen);
            this.Controls.Add(this.lstPorts);
            this.Controls.Add(this.textBoxOut);
            this.Name = "Form1";
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
            this.Text = "ZylGpsReceiver.NET Maps  Demo";
            this.Closed += new System.EventHandler(this.Form1_Closed);
            this.Load += new System.EventHandler(this.Form1_Load);
            this.groupBox3.ResumeLayout(false);
            this.groupBox3.PerformLayout();
            this.groupBox2.ResumeLayout(false);
            this.groupBox2.PerformLayout();
            this.groupBox1.ResumeLayout(false);
            this.groupBox1.PerformLayout();
            ((System.ComponentModel.ISupportInitialize)(this.pBox)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.gMaps)).EndInit();
            this.groupBoxMapProvider.ResumeLayout(false);
            this.groupBoxMapProvider.PerformLayout();
            this.ResumeLayout(false);
            this.PerformLayout();

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void btnOpen_Click(object sender, System.EventArgs e)
		{		    
		    if (lstPorts.SelectedIndex < 0)
		    {
		        MessageBox.Show("Select a port!");
		        return;
		    }

            if (radioButtonGoogleMaps.Checked)
                gMaps.MapProvider = MapProvider.GoogleMaps;
            else
                gMaps.MapProvider = MapProvider.OpenStreetMap;

            gpsReceiver.Port = GpsReceiver.StringToSerialCommPort(lstPorts.Items[lstPorts.SelectedIndex].ToString());
            if (gpsReceiver.Port == SerialCommPort.Custom)
            {
                gpsReceiver.CustomPortName = lstPorts.Items[lstPorts.SelectedIndex].ToString();
            }     
            gpsReceiver.BaudRate = (SerialBaudRate)(Convert.ToInt32(lstBaudRate.Items[lstBaudRate.SelectedIndex].ToString()));
		    //gpsReceiver.SatelliteTypes = SatelliteTypes.QzssSatellites | SatelliteTypes.GpsSatellites;
		    if (!gpsReceiver.Open())
		        MessageBox.Show("Cannot connect to " + gpsReceiver.Port.ToString());
		    else
		    {
		        gMaps.CenterPosition = gpsReceiver.Position;
                gMaps.MapType = MapType.SatelliteWithStreetNames;
                gMaps.DrawMap();
		    }
		}

		private void btnClose_Click(object sender, System.EventArgs e)
		{            
			gpsReceiver.Close();    
            //gpsReceiver.Track.ExportToGpx("d://netgpx.xml");
		}

		private void Form1_Closed(object sender, System.EventArgs e)
		{
			if (gpsReceiver != null)
				gpsReceiver.Close();
		}

        private void Set_textBoxOut(string text)
        {
            // InvokeRequired required compares the thread ID of the
            // calling thread to the thread ID of the creating thread.
            // If these threads are different, it returns true.
            if (this.textBoxOut.InvokeRequired)
            {
                SetTextCallback d = new SetTextCallback(Set_textBoxOut);
                textBoxOut.Invoke(d, new object[] { text });
            }
            else
            {
                this.textBoxOut.Text = text;
                this.textBoxOut.SelectionStart = textBoxOut.Text.Length;
                this.textBoxOut.SelectionLength = 0;
                this.textBoxOut.ScrollToCaret();
            }
        }

        private void Set_lblUTCTime(string text)
        {
            // InvokeRequired required compares the thread ID of the
            // calling thread to the thread ID of the creating thread.
            // If these threads are different, it returns true.
            if (this.lblUTCTime.InvokeRequired)
            {
                SetTextCallback d = new SetTextCallback(Set_lblUTCTime);
                lblUTCTime.Invoke(d, new object[] { text });
            }
            else
            {
                this.lblUTCTime.Text = text;                
            }
        }

        private void Set_lblLocalTime(string text)
        {
            // InvokeRequired required compares the thread ID of the
            // calling thread to the thread ID of the creating thread.
            // If these threads are different, it returns true.
            if (this.lblLocalTime.InvokeRequired)
            {
                SetTextCallback d = new SetTextCallback(Set_lblLocalTime);
                lblLocalTime.Invoke(d, new object[] { text });
            }
            else
            {
                this.lblLocalTime.Text = text;
            }
        }

        private void Set_textBoxLatDeg(string text)
        {
            // InvokeRequired required compares the thread ID of the
            // calling thread to the thread ID of the creating thread.
            // If these threads are different, it returns true.
            if (this.textBoxLatDeg.InvokeRequired)
            {
                SetTextCallback d = new SetTextCallback(Set_textBoxLatDeg);
                textBoxLatDeg.Invoke(d, new object[] { text });
            }
            else
            {
                this.textBoxLatDeg.Text = text;
            }
        }

        private void Set_textBoxLatMin(string text)
        {
            // InvokeRequired required compares the thread ID of the
            // calling thread to the thread ID of the creating thread.
            // If these threads are different, it returns true.
            if (this.textBoxLatMin.InvokeRequired)
            {
                SetTextCallback d = new SetTextCallback(Set_textBoxLatMin);
                textBoxLatMin.Invoke(d, new object[] { text });
            }
            else
            {
                this.textBoxLatMin.Text = text;
            }
        }

        private void Set_textBoxLatSec(string text)
        {
            // InvokeRequired required compares the thread ID of the
            // calling thread to the thread ID of the creating thread.
            // If these threads are different, it returns true.
            if (this.textBoxLatSec.InvokeRequired)
            {
                SetTextCallback d = new SetTextCallback(Set_textBoxLatSec);
                textBoxLatSec.Invoke(d, new object[] { text });
            }
            else
            {
                this.textBoxLatSec.Text = text;
            }
        }

        private void Set_textBoxLatDir(string text)
        {
            // InvokeRequired required compares the thread ID of the
            // calling thread to the thread ID of the creating thread.
            // If these threads are different, it returns true.
            if (this.textBoxLatDir.InvokeRequired)
            {
                SetTextCallback d = new SetTextCallback(Set_textBoxLatDir);
                textBoxLatDir.Invoke(d, new object[] { text });
            }
            else
            {
                this.textBoxLatDir.Text = text;
            }
        }

        private void Set_textBoxLongDeg(string text)
        {
            // InvokeRequired required compares the thread ID of the
            // calling thread to the thread ID of the creating thread.
            // If these threads are different, it returns true.
            if (this.textBoxLongDeg.InvokeRequired)
            {
                SetTextCallback d = new SetTextCallback(Set_textBoxLongDeg);
                textBoxLongDeg.Invoke(d, new object[] { text });
            }
            else
            {
                this.textBoxLongDeg.Text = text;
            }
        }

        private void Set_textBoxLongMin(string text)
        {
            // InvokeRequired required compares the thread ID of the
            // calling thread to the thread ID of the creating thread.
            // If these threads are different, it returns true.
            if (this.textBoxLongMin.InvokeRequired)
            {
                SetTextCallback d = new SetTextCallback(Set_textBoxLongMin);
                textBoxLongMin.Invoke(d, new object[] { text });
            }
            else
            {
                this.textBoxLongMin.Text = text;
            }
        }

        private void Set_textBoxLongSec(string text)
        {
            // InvokeRequired required compares the thread ID of the
            // calling thread to the thread ID of the creating thread.
            // If these threads are different, it returns true.
            if (this.textBoxLongSec.InvokeRequired)
            {
                SetTextCallback d = new SetTextCallback(Set_textBoxLongSec);
                textBoxLongSec.Invoke(d, new object[] { text });
            }
            else
            {
                this.textBoxLongSec.Text = text;
            }
        }

        private void Set_textBoxLongDir(string text)
        {
            // InvokeRequired required compares the thread ID of the
            // calling thread to the thread ID of the creating thread.
            // If these threads are different, it returns true.
            if (this.textBoxLongDir.InvokeRequired)
            {
                SetTextCallback d = new SetTextCallback(Set_textBoxLongDir);
                textBoxLongDir.Invoke(d, new object[] { text });
            }
            else
            {
                this.textBoxLongDir.Text = text;
            }
        }

        private void Set_textBoxAlt(string text)
        {
            // InvokeRequired required compares the thread ID of the
            // calling thread to the thread ID of the creating thread.
            // If these threads are different, it returns true.
            if (this.textBoxAlt.InvokeRequired)
            {
                SetTextCallback d = new SetTextCallback(Set_textBoxAlt);
                textBoxAlt.Invoke(d, new object[] { text });
            }
            else
            {
                this.textBoxAlt.Text = text;
            }
        }

        private void Set_textBoxSpeed(string text)
        {
            // InvokeRequired required compares the thread ID of the
            // calling thread to the thread ID of the creating thread.
            // If these threads are different, it returns true.
            if (this.textBoxSpeed.InvokeRequired)
            {
                SetTextCallback d = new SetTextCallback(Set_textBoxSpeed);
                textBoxSpeed.Invoke(d, new object[] { text });
            }
            else
            {
                this.textBoxSpeed.Text = text;
            }
        }

        private void Set_textBoxCourse(string text)
        {
            // InvokeRequired required compares the thread ID of the
            // calling thread to the thread ID of the creating thread.
            // If these threads are different, it returns true.
            if (this.textBoxCourse.InvokeRequired)
            {
                SetTextCallback d = new SetTextCallback(Set_textBoxCourse);
                textBoxCourse.Invoke(d, new object[] { text });
            }
            else
            {
                this.textBoxCourse.Text = text;
            }
        }

        private void Set_textBoxSatCount(string text)
        {
            // InvokeRequired required compares the thread ID of the
            // calling thread to the thread ID of the creating thread.
            // If these threads are different, it returns true.
            if (this.textBoxSatCount.InvokeRequired)
            {
                SetTextCallback d = new SetTextCallback(Set_textBoxSatCount);
                textBoxSatCount.Invoke(d, new object[] { text });
            }
            else
            {
                this.textBoxSatCount.Text = text;
            }
        }

        private void Set_lblDetect(string text)
        {
            // InvokeRequired required compares the thread ID of the
            // calling thread to the thread ID of the creating thread.
            // If these threads are different, it returns true.
            if (this.lblDetect.InvokeRequired)
            {
                SetTextCallback d = new SetTextCallback(Set_lblDetect);
                lblDetect.Invoke(d, new object[] { text });
            }
            else
            {
                this.lblDetect.Text = text;
            }
        }

		private void serialPort_Received(object sender, ZylSoft.Gps.DataEventArgs e)
		{
			Set_textBoxOut(textBoxOut.Text + e.Buffer);			

			Set_lblUTCTime(gpsReceiver.Position.GetUtcDateTime().ToString());
			Set_lblLocalTime(gpsReceiver.Position.GetLocalDateTime().ToString());

			Set_textBoxLatDeg(gpsReceiver.Position.LatitudeDegree.ToString());
			Set_textBoxLatMin(gpsReceiver.Position.LatitudeMinute.ToString());
			Set_textBoxLatSec(gpsReceiver.Position.LatitudeSecond.ToString());
			if (gpsReceiver.Position.LatitudeDirection == CardinalPoint.North)
				Set_textBoxLatDir("North");
			else
				Set_textBoxLatDir("South");

			Set_textBoxLongDeg(gpsReceiver.Position.LongitudeDegree.ToString());
            Set_textBoxLongMin(gpsReceiver.Position.LongitudeMinute.ToString());
            Set_textBoxLongSec(gpsReceiver.Position.LongitudeSecond.ToString());
			if (gpsReceiver.Position.LongitudeDirection == CardinalPoint.East)
                Set_textBoxLongDir("East");
			else
                Set_textBoxLongDir("West");

            Set_textBoxAlt(gpsReceiver.Position.Altitude.ToString());
            Set_textBoxSpeed(gpsReceiver.Position.SpeedAsKmh.ToString());
            Set_textBoxCourse(gpsReceiver.Position.Course.ToString());
            Set_textBoxSatCount(gpsReceiver.Position.SatelliteCount.ToString());            
        }

		private void gpsReceiver_LatitudeChanged(object sender, ZylSoft.Gps.PositionEventArgs e)
		{
			Set_textBoxOut(textBoxOut.Text + Environment.NewLine + "Latitude changed: " + 
				Position.DmsToDecimalDegrees(e.Degree, e.Minute, e.Second, 
				e.Direction).ToString() + Environment.NewLine);			
		}

		private void gpsReceiver_LongitudeChanged(object sender, ZylSoft.Gps.PositionEventArgs e)
		{
			Set_textBoxOut(textBoxOut.Text + Environment.NewLine + "Longitude changed: " + 
				Position.DmsToDecimalDegrees(e.Degree, e.Minute, e.Second, 
				e.Direction).ToString() + Environment.NewLine);			
		}

		private void gpsReceiver_AltitudeChanged(object sender, ZylSoft.Gps.ParamEventArgs e)
		{
			Set_textBoxOut(textBoxOut.Text + Environment.NewLine + "Altitude changed: " + e.Value.ToString() + " m" + Environment.NewLine);		
		}

		private void gpsReceiver_Connected(object sender, ZylSoft.Gps.ConnectionEventArgs e)
		{
			Set_textBoxOut(textBoxOut.Text + Environment.NewLine + "Connected to: " + e.Port.ToString() + Environment.NewLine);			
		}

		private void gpsReceiver_Disconnected(object sender, ZylSoft.Gps.ConnectionEventArgs e)
		{
			Set_textBoxOut(textBoxOut.Text + Environment.NewLine + "Disconnected from: " + e.Port.ToString() + Environment.NewLine);			
		}

		private void gpsReceiver_HeadingChanged(object sender, ZylSoft.Gps.ParamEventArgs e)
		{
			Set_textBoxOut(textBoxOut.Text + Environment.NewLine + "Heading changed: " + e.Value.ToString() + " degrees" + Environment.NewLine);		
		}

		private void gpsReceiver_SpeedChanged(object sender, ZylSoft.Gps.ParamEventArgs e)
		{
			Set_textBoxOut(textBoxOut.Text + Environment.NewLine + "Speed changed: " + e.Value.ToString() + " km/h" + Environment.NewLine);		
		}

        private void btnDetect_Click(object sender, EventArgs e)
        {
            SerialCommPort port;
			SerialBaudRate baudRate;
            m_DetectCancel = false;
			if (gpsReceiver.DetectGps(out port, out baudRate))
			{
				MessageBox.Show("Port: " + gpsReceiver.SerialCommPortToString(port) + ", Baud Rate: " + baudRate.ToString());
				lstPorts.SelectedIndex = lstPorts.Items.IndexOf(gpsReceiver.SerialCommPortToString(port));
				lstBaudRate.SelectedIndex = lstBaudRate.Items.IndexOf(((int)baudRate).ToString());
			}
			else
				MessageBox.Show("No GPS detected.");
            lblDetect.Text = string.Empty;
		}

        private void Form1_Load(object sender, EventArgs e)
        {
            lstBaudRate.SelectedIndex = 8;

            lstPorts.Items.Clear();
            String[] ports = ZylSoft.Gps.GpsReceiver.GetExistingCommPortNames();
            foreach (String i in ports)
            {
                lstPorts.Items.Add(i);
            }
        }

        private void RefreshPaintBox()
        {
            try
            {
                // InvokeRequired required compares the thread ID of the
                // calling thread to the thread ID of the creating thread.
                // If these threads are different, it returns true.
                if (this.InvokeRequired)
                {
                    this.Invoke(new RefreshPaintBoxCallBack(RefreshPaintBox));
                    return;
                }
                else
                    this.pBox.Refresh();                    
            }
            catch { }
        }

        private void gpsReceiver_SatellitesReceived(object sender, EventArgs e)
        {
            RefreshPaintBox();
        }

        private void pBox_Paint(object sender, PaintEventArgs e)
        {            
            gpsReceiver.DrawSatellites(e.Graphics, Math.Min(pBox.Width, pBox.Height)/2, Color.Black, Color.White);
        }

        private void gpsReceiver_Detecting(object sender, DetectEventArgs e)
        {
            Set_lblDetect("Detecting: " + e.Port.ToString() + " " + e.BaudRate.ToString());
            e.Cancel = m_DetectCancel;
        }

        private void btnCancel_Click(object sender, EventArgs e)
        {
            m_DetectCancel = true;            
        }

        private void gpsReceiver_Position2DChanged(object sender, DmsPositionEventArgs e)
        {
            //Set_textBoxOut(textBoxOut.Text + Environment.NewLine + "Position2D changed." + Environment.NewLine);	            
            //  Set_textBoxOut(textBoxOut.Text + "2D Position Changed. Distance to New York City = " + Position.DistanceAsKm(e.Position.GetLatitudeAsDecimalDegrees(), e.Position.GetLongitudeAsDecimalDegrees(), 40.77, 73.98).ToString() + " KM");            
            if (gMaps.Paths.Count == 0)
            {
                gMaps.Paths.Add(new Path());
                gMaps.Paths[0].StrokeStyle.Color = Color.Blue;
                gMaps.Paths[0].StrokeStyle.Weight = 2;  
                //gMaps.Paths[0].PathType = PathType.Polygon;
            }
            gMaps.Paths[0].Add((Position)gpsReceiver.Position.Clone());
            gMaps.CenterPositionMarker.Title = e.Position.LatitudeAsDecimalDegrees.ToString() + ", " +
                                               e.Position.LongitudeAsDecimalDegrees.ToString();
            if (InvokeRequired)
            {
                Invoke(new MethodInvoker(delegate () { gMaps.RefreshMap(); }));
            }
            else
            {
                gMaps.RefreshMap();
            }

            //Marker marker = new Marker();
            //marker.Position = (Position) gpsReceiver.Position.Clone();
            //marker.Text = gpsReceiver.Position.LatitudeAsDecimalDegrees.ToString();
            //gMaps.Markers.Add(marker);
        }

        private void gpsReceiver_WaypointReceived(object sender, WaypointEventArgs e)
        {
            Set_textBoxOut(textBoxOut.Text + Environment.NewLine + "Waypoint Received: " + e.ReceivedWaypoint.Name + Environment.NewLine);	
        }

        private void gpsReceiver_ActiveRouteReceived(object sender, EventArgs e)
        {
            Set_textBoxOut(textBoxOut.Text + Environment.NewLine + "Active Route Received: " + gpsReceiver.ActiveRoute.Name + Environment.NewLine);
        }

        private void gpsReceiver_CourseChanged(object sender, ParamEventArgs e)
        {
            Set_textBoxOut(textBoxOut.Text + Environment.NewLine + "Course changed: " + e.Value.ToString() + " degrees" + Environment.NewLine);		
        }

        private void gpsReceiver_SatelliteReceived(object sender, SatelliteEventArgs e)
        {
            //Set_textBoxOut(textBoxOut.Text + Environment.NewLine + "Satellite received: " + e.ReceivedSatellite.PseudoRandomCode.ToString() + Environment.NewLine);	
        }

        private void gpsReceiver_Idle(object sender, EventArgs e)
        {
            Set_textBoxOut(textBoxOut.Text + Environment.NewLine + "Idle" + Environment.NewLine);
        }

        private void gpsReceiver_Resume(object sender, EventArgs e)
        {
            Set_textBoxOut(textBoxOut.Text + Environment.NewLine + "Resume" + Environment.NewLine);
        }

        private void gpsReceiver_Faulted(object sender, ConnectionEventArgs e)
        {
            Set_textBoxOut(textBoxOut.Text + Environment.NewLine + "Faulted: " + e.Port.ToString() + Environment.NewLine);
        }

        private void label13_Click(object sender, EventArgs e)
        {
            
        }
    }    
}
